"use strict";
function makeMap(e) {
  for (var a = {}, t = e.split(","), l = t.length; l--; ) a[t[l]] = !0;
  return a;
}
var canIUse = wx.canIUse("editor");
module.exports = {
  filter(node, cxt) {
    if (node.name === "img" && node.attrs.style && node.attrs.style.length) {
      node.attrs.style = node.attrs.style
        .replace(/width:(\s*)auto(\s*)!important/, "")
        .replace(/height:(\s*)auto(\s*)!important/, "");
    }
    // node.attrs.style =
    //   node.attrs.style +
    //   ";font-size:18px !important;background-color:#ffffff;color:#333333;"; // 给标签添加某个属性
  },
  highlight: null,
  onText: null,
  blankChar: makeMap(" , ,\t,\r,\n,\f"),
  blockTags: makeMap(
    "address,article,aside,body,caption,center,cite,footer,header,html,nav,section" +
      (canIUse ? "" : ",pre")
  ),
  ignoreTags: makeMap(
    "area,base,basefont,canvas,command,embed,frame,iframe,input,isindex,keygen,link,map,meta,param,script,source,style,svg,textarea,title,track,use,wbr" +
      (canIUse ? ",rp" : "")
  ),
  richOnlyTags: makeMap(
    "a,colgroup,fieldset,legend,picture,table" +
      (canIUse ? ",bdi,bdo,rt,ruby" : "")
  ),
  selfClosingTags: makeMap(
    "area,base,basefont,br,col,circle,ellipse,embed,frame,hr,img,input,isindex,keygen,line,link,meta,param,path,polygon,rect,source,track,use,wbr"
  ),
  trustAttrs: makeMap(
    "align,alt,app-id,author,autoplay,border,cellpadding,cellspacing,class,color,colspan,controls,data-src,dir,face,height,href,id,ignore,loop,media,muted,name,path,poster,rowspan,size,span,src,start,style,type,unit-id,width,xmlns"
  ),
  boolAttrs: makeMap("autoplay,controls,ignore,loop,muted"),
  trustTags: makeMap(
    "a,abbr,ad,audio,b,blockquote,br,code,col,colgroup,dd,del,dl,dt,div,em,fieldset,h1,h2,h3,h4,h5,h6,hr,i,img,ins,label,legend,li,ol,p,q,source,span,strong,sub,sup,table,tbody,td,tfoot,th,thead,tr,title,ul,video" +
      (canIUse ? ",bdi,bdo,caption,pre,rt,ruby" : "")
  ),
  userAgentStyles: {
    address: "font-style:italic",
    big: "display:inline;font-size:1.2em",
    blockquote:
      "background-color:#f6f6f6;border-left:3px solid #dbdbdb;color:#6c6c6c;padding:5px 0 5px 10px",
    caption: "display:table-caption;text-align:center",
    center: "text-align:center",
    cite: "font-style:italic",
    dd: "margin-left:40px",
    mark: "background-color:yellow",
    pre: "font-family:monospace;white-space:pre;overflow:scroll",
    s: "text-decoration:line-through",
    small: "display:inline;font-size:0.8em",
    u: "text-decoration:underline",
  },
};
