// components/toastTip/toastTip.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    tip: {
      type: String,
      value: "「添加小程序」优惠不错过",
    },
    top: {
      type: Number,
      value: 68,
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    showTip: false,
    time: null,
  },

  lifetimes: {
    attached: function () {
      const toastTip = wx.getStorageSync("TOASTTIP");
      if (!toastTip) {
        this.setData({
          showTip: true,
        });
        // 在组件实例进入页面节点树时执行
        this.data.time = setTimeout(() => {
          this.handleCloseTip();
        }, 30000);
        wx.setStorageSync("TOASTTIP", true);
      }
    },
  },

  /**
   * 组件的方法列表
   */
  methods: {
    handleCloseTip: function () {
      this.setData({
        showTip: false,
      });
      clearTimeout(this.data.time);
      this.data.time = null;
    },
  },
});
