const { api_get_mobile_prefix } = require('../../utils/api.js');
const util = require('../../utils/util.js');
const net = require('../../utils/net.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    areaData: [],
    selectId: 0
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const prefixArr = util.getStorageSync("MOBILEPREFIXDATA");
    if (prefixArr) {
      this.setData({
        areaData: JSON.parse(decodeURIComponent(prefixArr))
      })
    } else {
      this.loadPrefix();
    }

    if (options && options.id) {
      this.setData({
        selectId: options.id
      })
    }

    if (options && options.name) {
      wx.setNavigationBarTitle({
        title: options.name,
      })
    }
  },

  loadPrefix: function () {
    let params = {};
    params.data = {
      range: 'B',
      prefix: '1'
    }
    params.url = api_get_mobile_prefix;
    net.req(params).then((res) => {
      if (res && Array.isArray(res) && res.length > 0) {
        let prefixArr = [];
        res.forEach((vvv, iii, aaa) => {
          let { list } = vvv;
          prefixArr = prefixArr.concat(list);
        });
        util.setStorageSync("MOBILEPREFIXDATA", encodeURIComponent(JSON.stringify(prefixArr)))
        this.setData({
          isLoading: false,
          areaData: prefixArr
        });
      }
    });
  },

  tapAction(e) {
    const { currentIndex } = e.currentTarget.dataset;
    let pages = getCurrentPages(); /*在内存中的所有页面栈对象*/
    let prePage = pages[pages.length - 2]; /*我的页面对象*/
    if (prePage) {
      const data = this.data.areaData[currentIndex];
      if (prePage.areaCodeCallback) prePage.areaCodeCallback({
        prefixIndex: currentIndex,
        areaData: data
      });
      wx.navigateBack();
    } else {
      wx.navigateBack();
    }
  }
})