// pages/message/message.js
const net = require("../../utils/net.js");
const utils = require("../../utils/util.js");
const { api_msg_list, api_msg_info } = require("../../utils/api.js");

Page({
  /**
   * 页面的初始数据
   */
  data: {
    messageList: [],
    limit: 20,
    page: 1,
    isEmpty: false,
    userInfo: null,
    isEnd: false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function () {
    this.judgeUserLogin(true);
  },

  onShow: function () {
    if (this._onLoad) {
      this._onLoad = false;
    } else {
      this.judgeUserLogin(false);
    }
  },

  handleEmptyAction() {
    wx.navigateTo({
      url: "/pages/login/login",
    });
  },

  judgeUserLogin(state) {
    const { userInfo } = this.data;
    const userData = utils.getStorageSync("USERINFO");
    if (userData && userData.token) {
      this._onLoad = state;
      !userInfo &&
        this.setData({
          userInfo: userData,
        });
      this.loadMessageData({
        isRefresh: true,
      });
    }
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if (!this._isLoad) {
      this.data.page += 1;
      this.loadMessageData({ isRefresh: false });
    }
  },

  loadMessageData(obj) {
    const { limit, messageList, page } = this.data;
    let params = {};
    params.url = api_msg_list;
    params.data = {
      limit: limit,
      page: page,
    };
    this._isload = true;
    net.req(params, true).then(
      (data) => {
        if (obj.isRefresh) {
          this.setData({
            messageList: data.list,
            isEnd: data.list.length < limit,
          });
          this._refresh = false;
          this._isload = false;
        } else {
          if (data.list.length) {
            this.setData({
              messageList: messageList.concat(data.list),
              isEnd: data.list.length < limit,
            });
          }
          this._isload = data.list.length < limit;
        }

        this.setData({
          isEmpty: !this.data.messageList.length,
        });
      },
      (e) => {
        obj.isRefresh ? (this._refresh = false) : (this._isload = false);
      }
    );
  },

  tapCellAction(e) {
    const { currentItem, currentIndex } = e.currentTarget.dataset;
    if (currentItem.msgType == 8) {
      wx.navigateTo({
        url: `/pages/newDetail/newDetail?newId=${currentItem.data.subId}`,
      });
    }
    this.setMessageState(currentItem.id, currentIndex);
  },

  setMessageState(messageId, index) {
    let params = {};
    params.url = api_msg_info;
    params.data = {
      id: messageId,
    };
    net.req(params, true).then(() => {
      this.setData({
        [`messageList[${index}].state`]: 1,
      });
    });
  },

  refreshCallback() {
    this.judgeUserLogin();
  },
});
