// pages/pulishPost/pulishPost.js
const net = require("../../utils/net.js");
const { api_tips_add } = require("../../utils/api.js");
const util = require("../../utils/util.js");

Page({
  /**
   * 页面的初始数据
   */
  data: {
    tagNameList: [],
    tagIdList: [],
    inputValue: "",
    imgs: [],
    tagData: {},
  },

  onLoad: function (options) {
    if (options && options.data) {
      const data = JSON.parse(options.data);
      const { tagNameList, tagIdList } = this.data;
      if (data.tagName) {
        tagNameList.push(data.tagName);
        this.setData({
          tagNameList: tagNameList,
        });
        tagIdList.push(data.id);
      }
    }
  },

  inputChange(event) {
    const { value } = event.detail;
    this.data.inputValue = value;
  },

  tapAddTagAction() {
    const { tagIdList, tagNameList } = this.data;
    const _this = this;
    wx.navigateTo({
      url: `/pages/selectTags/selectTags`,
      events: {
        acceptDataFromTagsPage(data) {
          tagIdList.push(data.id);
          tagNameList.push(data.tagName);
          _this.setData({
            tagNameList: tagNameList,
          });
        },
      },
    });
  },
  tapRemoveTagAction(e) {
    const { currentIndex } = e.currentTarget.dataset;
    const { tagNameList, tagIdList } = this.data;
    tagNameList.splice(currentIndex, 1);
    tagIdList.splice(currentIndex, 1);
    this.setData({
      tagNameList: tagNameList,
    });
  },

  selectImgsChange(e) {
    this.data.imgs = e.detail.imgs;
  },
  tapPulishAction() {
    const { tagIdList, inputValue, imgs } = this.data;
    const imgsUrl = [];
    if ((imgs.length || inputValue.length) && !this._isPulish) {
      for (let i = 0, n = imgs.length; i < n; i++) {
        const imgObj = imgs[i];
        if (imgObj.type != 3) {
          util.showToast({
            title:
              imgObj.type == 1
                ? "图片上传中,请您稍后再试!"
                : "您选择的图片存在违规.请您重新选择图片",
          });
          return;
        }
        imgsUrl.push(imgObj.src);
      }
      let params = {};
      params.url = api_tips_add;
      params.data = {};
      if (imgs.length) params.data.imgsUrl = JSON.stringify(imgsUrl);
      if (inputValue.length) params.data.content = inputValue;
      if (tagIdList.length) params.data.tagIdList = JSON.stringify(tagIdList);
      util.showLoading({
        title: "发布中...",
      });
      this._isPulish = true;
      net.req(params, true).then(
        (data) => {
          util.showToast({ title: "发布成功" });
          const pages = getCurrentPages(); /*在内存中的所有页面栈对象*/
          const reloadPage = pages[pages.length - 2]; /*我的页面对象*/
          reloadPage &&
            reloadPage.refreshCallback &&
            reloadPage.refreshCallback();
          wx.navigateBack();
          util.hideLoading();
          this._isPulish = false;
        },
        (e) => {
          util.showToast({ title: e.msg || "" });
          util.hideLoading();
          this._isPulish = false;
        }
      );
    } else {
      util.showToast({ title: "请输入您要发布的内容..." });
    }
  },
});
