export default class Poster {
  palette(posterArr) {
    if (posterArr && Array.isArray) {
      let canvasObj = {
        views: [],
      };
      const pixelRatio = wx.getSystemInfoSync().pixelRatio;
      posterArr.forEach((val, i, arr) => {
        let {
          id,
          left,
          top,
          width,
          height,
          color,
          backgroundColor,
          fontSize,
          fontWeight,
          borderRadius,
          dataset,
        } = val;

        fontSize = fontSize.replace("px", "");
        fontSize = Math.ceil(Number(fontSize) * pixelRatio) + "px";
        top = Math.ceil(top * pixelRatio);
        left = Math.ceil(left * pixelRatio);
        if (pixelRatio > 3) {
          // 曲面屏做适配
          width = Math.ceil(width * pixelRatio) + 5;
        } else {
          width = Math.ceil(width * pixelRatio);
        }
        height = Math.ceil(height * pixelRatio);
        borderRadius = borderRadius.replace("px", "");
        borderRadius = Math.ceil(Number(borderRadius) * pixelRatio) + "px";

        let { what, uri } = dataset;
        if (what) {
          what = what.toString();
        }
        switch (id) {
          case "container":
            Object.assign(canvasObj, {
              width: `${width}px`,
              height: `${height}px`,
              background: "#ffffff",
              borderRadius: "0px",
            });
            break;
          case "rect":
            canvasObj.views.push({
              type: "rect",
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                backgroundColor: `${backgroundColor || "#FFFFFF"}`,
                borderRadius: `${borderRadius || 0}`,
              },
            });
            break;
          case "image":
            canvasObj.views.push({
              type: "image",
              url: uri || what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                borderRadius: `${borderRadius || 0}`,
              },
            });
            break;
          case "coverImage":
            canvasObj.views.push({
              type: "image",
              url:
                uri ||
                what ||
                "https://static.hoolihome.com/weapp/daily/poster-cover.png",
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
              },
            });
            break;
          case "content":
            canvasObj.views.push({
              type: "text",
              text: what.replace(/[\r\n]/g, ""),
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: `${backgroundColor}`,
                borderRadius: `${borderRadius}`,
                maxLines: 3,
              },
            });
            break;
          case "tip":
            canvasObj.views.push({
              type: "text",
              text: what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width + 10}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
              },
            });
            break;
          default:
            canvasObj.views.push({
              type: "text",
              text: what,
              css: {
                left: `${left}px`,
                top: `${top}px`,
                width: `${width}px`,
                height: `${height}px`,
                fontSize: `${fontSize}`,
                color: `${color}`,
                fontWeight: `${fontWeight}`,
                backgroundColor: "#FFFFFF",
              },
            });
            break;
        }
      });
      return canvasObj;
    }
  }
}
